package com.graphaware.neo4j.representation.property;

/**
 * Interface for (typically immutable) components that contain some properties and are able to return a copy
 * (again immutable) of themselves, with a single property added.
 */
public interface MakesCopyWithProperty<T extends MakesCopyWithProperty<T>> {

    /**
     * Make a copy of this instance with an extra key-value pair.
     *
     * @param key   new key
     * @param value new value
     * @return copy of this instance with an extra key-value pair.
     */
    public T with(String key, String value);
}
