package com.graphaware.neo4j.representation.property;

import org.neo4j.graphdb.PropertyContainer;

import java.util.Map;

/**
 * Simple concrete implementation of {@link Properties} that {@link MakesCopyWithProperty} and {@link MakesCopyWithoutProperty}.
 */
public class SimpleCopyMakingProperties extends CopyMakingProperties<SimpleCopyMakingProperties> implements MakesCopyWithPropertyProperties<SimpleCopyMakingProperties>, MakesCopyWithoutPropertyProperties<SimpleCopyMakingProperties> {

    /**
     * Construct a representation of properties from a {@link PropertyContainer}.
     *
     * @param propertyContainer to take (copy) properties from.
     */
    public SimpleCopyMakingProperties(PropertyContainer propertyContainer) {
        super(propertyContainer);
    }

    /**
     * Construct a representation of properties from a {@link Map}.
     *
     * @param properties to take (copy).
     */
    public SimpleCopyMakingProperties(Map<String, String> properties) {
        super(properties);
    }

    /**
     * Construct a representation of properties from a {@link String}.
     *
     * @param string to construct properties from. Must be of the form key1#value1#key2#value2... (assuming the default
     *               {@link com.graphaware.neo4j.utils.Constants#SEPARATOR}.
     */
    public SimpleCopyMakingProperties(String string) {
        super(string);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    protected SimpleCopyMakingProperties newInstance(Map<String, String> props) {
        return new SimpleCopyMakingProperties(props);
    }
}
