package com.graphaware.neo4j.representation.property;

import org.neo4j.graphdb.PropertyContainer;

import java.util.Map;

/**
 * Simple {@link Properties}. Provides to/from String conversion and access to the represented properties, nothing else.
 */
public class SimpleProperties extends StringConvertibleProperties<SimpleProperties> implements Properties {

    /**
     * Construct a representation of properties from a {@link PropertyContainer}.
     *
     * @param propertyContainer to take (copy) properties from.
     */
    public SimpleProperties(PropertyContainer propertyContainer) {
        super(propertyContainer);
    }

    /**
     * Construct a representation of properties from a {@link Map}.
     *
     * @param properties to take (copy).
     */
    public SimpleProperties(Map<String, String> properties) {
        super(properties);
    }

    /**
     * Construct a representation of properties from a {@link String}.
     *
     * @param string to construct properties from. Must be of the form key1#value1#key2#value2... (assuming the default
     *               {@link com.graphaware.neo4j.utils.Constants#SEPARATOR}.
     */
    public SimpleProperties(String string) {
        super(string);
    }
}
