package com.graphaware.neo4j.representation.relationship;

import com.graphaware.neo4j.representation.property.Properties;
import org.neo4j.graphdb.Direction;
import org.neo4j.graphdb.RelationshipType;

/**
 * A representation of a Neo4j {@link org.neo4j.graphdb.Relationship}.
 */
public interface Relationship<P extends Properties> {

    /**
     * Get the relationship type.
     *
     * @return type.
     */
    RelationshipType getType();

    /**
     * Get the relationship direction.
     *
     * @return direction.
     */
    Direction getDirection();

    /**
     * Get the properties attached to the relationship.
     *
     * @return properties.
     */
    P getProperties();
}
