package com.graphaware.neo4j.utils.array;

import java.util.Arrays;

/**
 * Static utility methods for dealing with arrays.
 */
public final class ArrayUtils {

    /**
     * Check if the given object is a primitive array.
     *
     * @param o to check.
     * @return iff o is a primitive array.
     */
    public static boolean isPrimitiveArray(Object o) {
        if (o instanceof byte[]) {
            return true;
        } else if (o instanceof char[]) {
            return true;
        } else if (o instanceof boolean[]) {
            return true;
        } else if (o instanceof long[]) {
            return true;
        } else if (o instanceof double[]) {
            return true;
        } else if (o instanceof int[]) {
            return true;
        } else if (o instanceof short[]) {
            return true;
        } else if (o instanceof float[]) {
            return true;
        }
        return false;
    }

    /**
     * Convert a primitive array to string.
     *
     * @param o to convert.
     * @return as string.
     * @throws IllegalArgumentException if o isn't a primitive array.
     */
    public static String primitiveArrayToString(Object o) {
        if (o instanceof byte[]) {
            return Arrays.toString((byte[]) o);
        } else if (o instanceof char[]) {
            return Arrays.toString((char[]) o);
        } else if (o instanceof boolean[]) {
            return Arrays.toString((boolean[]) o);
        } else if (o instanceof long[]) {
            return Arrays.toString((long[]) o);
        } else if (o instanceof double[]) {
            return Arrays.toString((double[]) o);
        } else if (o instanceof int[]) {
            return Arrays.toString((int[]) o);
        } else if (o instanceof short[]) {
            return Arrays.toString((short[]) o);
        } else if (o instanceof float[]) {
            return Arrays.toString((float[]) o);
        }
        throw new IllegalArgumentException("Object must be a primitive array!");
    }

    private ArrayUtils() {
    }
}
