package com.graphaware.neo4j.utils.tx.mutate;

import org.neo4j.graphdb.Relationship;

/**
 * A "fake" relationship that maintains a list of properties separately to the actual real relationship, but initially
 * (at construction time) extracts them from the real relationship.
 */
public class FakeRelationshipWithRealProps extends FakeRelationship {

    public FakeRelationshipWithRealProps(Relationship realRelationship) {
        super(realRelationship);
        for (String key : realRelationship.getPropertyKeys()) {
            setProperty(key, realRelationship.getProperty(key));
        }
    }
}
